import type { Firestore } from 'firebase-admin/firestore';
import { FirestoreCollection } from './FirestoreCollection';
import type { FirestorePath } from './FirestorePath';
import { FirestoreSnapshot } from './FirestoreSnapshot';
type FirestoreValueTypeWithoutArray = boolean | Uint8Array | string | number | null | {
    [key: string]: FirestoreValueType;
};
export type FirestoreValueType = FirestoreValueTypeWithoutArray | FirestoreValueTypeWithoutArray[];
export declare class FirestoreDocument<Values extends Record<string, FirestoreValueType>, SubCollections extends Record<string, FirestoreCollection<any>> = never> {
    private readonly firestore;
    private readonly path;
    constructor(firestore: Firestore, path: FirestorePath);
    getSubCollection<Key extends keyof SubCollections & string>(key: Key): SubCollections[Key];
    setValues(values: Partial<Values>): Promise<void>;
    snapshot(): Promise<FirestoreSnapshot<Values>>;
}
export declare namespace FirestoreDocument {
    type ValuesOf<Document extends FirestoreDocument<any, any>> = Document extends FirestoreDocument<infer Values, any> ? Values : never;
    type SubCollectionsOf<Document extends FirestoreDocument<any, any>> = Document extends FirestoreDocument<any, infer SubCollections> ? SubCollections : never;
}
export {};
