import type { FirebaseApp } from './FirebaseApp';
import { type Auth as AuthInstance, type UserCredential } from 'firebase/auth';
export declare class FirebaseAuthenticator {
    private readonly options;
    private readonly authInstance;
    constructor(options: FirebaseApp.Options, authInstance: AuthInstance);
    createUser(email: string, password: string): Promise<UserCredential>;
    signIn(email: string, password: string): Promise<UserCredential>;
    signOut(): Promise<void>;
}
