import { type Firestore as FirestoreInstance, type DocumentSnapshot } from 'firebase/firestore';
import type { FirestoreCollection, FirestoreDocument, FirestorePath } from '../firestore';
import type { FirebaseApp } from './FirebaseApp';
export declare class FirebaseFirestoreDocument<FirestoreScheme extends FirestoreDocument<any, any>> {
    private readonly options;
    private readonly path;
    private readonly firestoreInstance;
    constructor(options: FirebaseApp.Options, path: FirestorePath, firestoreInstance: FirestoreInstance);
    getSubCollection<Key extends keyof FirestoreDocument.SubCollectionsOf<FirestoreScheme> & string>(key: Key): FirestoreDocument.SubCollectionsOf<FirestoreScheme>[Key];
    setValues(values: FirestoreDocument.ValuesOf<FirestoreScheme>): Promise<void>;
    snapshot(): Promise<FirebaseFirestoreSnapshot<FirestoreDocument.ValuesOf<FirestoreScheme>>>;
}
export declare class FirebaseFirestoreCollection<FirestoreScheme extends FirestoreCollection<any>> {
    private readonly options;
    private readonly path;
    private readonly firestoreInstance;
    constructor(options: FirebaseApp.Options, path: FirestorePath, firestoreInstance: FirestoreInstance);
    addDocument<Key extends keyof FirestoreCollection.DocumentsOf<FirestoreScheme> & string>(key: Key, documentValues: FirestoreDocument.ValuesOf<FirestoreCollection.DocumentsOf<FirestoreScheme>[Key]>): Promise<void>;
    getDocument<Key extends keyof FirestoreCollection.DocumentsOf<FirestoreScheme> & string>(key: Key): FirestoreCollection.DocumentsOf<FirestoreScheme>[Key];
    removeDocument<Key extends keyof FirestoreCollection.DocumentsOf<FirestoreScheme> & string>(key: Key): Promise<void>;
}
export declare class FirebaseFirestoreSnapshot<T> {
    private readonly options;
    private readonly snapshot;
    constructor(options: FirebaseApp.Options, snapshot: DocumentSnapshot<T>);
    get exists(): boolean;
    get data(): T;
}
