"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapRecord = exports.entries = exports.values = exports.keys = void 0;
function keys(record) {
    return Object.keys(record);
}
exports.keys = keys;
function values(record) {
    return Object.values(record);
}
exports.values = values;
function entries(record) {
    return Object.entries(record).map(entry => ({
        key: entry[0],
        value: entry[1]
    }));
}
exports.entries = entries;
function mapRecord(record, callbackFn) {
    const newRecord = {};
    for (const entry of entries(record))
        newRecord[entry.key] = callbackFn(entry.value, entry.key);
    return newRecord;
}
exports.mapRecord = mapRecord;
